Package com.sap.ai.sdk.grounding.client

# Class PipelinesApi

java.lang.Object
com.sap.cloud.sdk.services.openapi.apache.apiclient.BaseApi
com.sap.ai.sdk.grounding.client.PipelinesApi

public class PipelinesApi extends com.sap.cloud.sdk.services.openapi.apache.apiclient.BaseApi
Grounding in version 0.1.0.

Grounding is a service designed to handle data-related tasks, such as grounding and retrieval, using vector databases. It provides specialized data retrieval through these databases, grounding the retrieval process with your own external and context-relevant data. Grounding combines generative AI capabilities with the ability to use real-time, precise data to improve decision-making and business operations for specific AI-driven business solutions.

- ## Field Summary

  ### Fields inherited from class com.sap.cloud.sdk.services.openapi.apache.apiclient.BaseApi

  `apiClient, defaultHeaders`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PipelinesApi(com.sap.cloud.sdk.cloudplatform.connectivity.Destination httpDestination)`
  Instantiates this API class to invoke operations on the Grounding.
  `PipelinesApi(com.sap.cloud.sdk.services.openapi.apache.apiclient.ApiClient apiClient)`
  Instantiates this API class to invoke operations on the Grounding based on a given `ApiClient`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PipelineId`
  `createPipeline(String aiResourceGroup, CreatePipeline createPipeline)`
  Pipeline Creation
  `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiResponse`
  `deletePipelineById(String aiResourceGroup, String pipelineId)`
  Delete pipeline
  `DocumentsStatusResponse`
  `getAllDocumentsForPipeline(String aiResourceGroup, String pipelineId)`
  Get Documents for a Pipeline
  `DocumentsStatusResponse`
  `getAllDocumentsForPipeline(String aiResourceGroup, String pipelineId, Integer $top, Integer $skip, Boolean $count)`
  Get Documents for a Pipeline
  `GetPipelineExecutions`
  `getAllExecutionsForPipeline(String aiResourceGroup, String pipelineId)`
  Get Pipeline Executions
  `GetPipelineExecutions`
  `getAllExecutionsForPipeline(String aiResourceGroup, String pipelineId, Boolean lastExecution, Integer $top, Integer $skip, Boolean $count)`
  Get Pipeline Executions
  `GetPipelines`
  `getAllPipelines(String aiResourceGroup)`
  Get Pipelines
  `GetPipelines`
  `getAllPipelines(String aiResourceGroup, String metadataConfigId, Integer $top, Integer $skip, Boolean $count)`
  Get Pipelines
  `PipelineDocumentResponse`
  `getDocumentByIdForPipeline(String aiResourceGroup, String pipelineId, String documentId)`
  Get Document by ID for a Pipeline
  `PipelineDocumentResponse`
  `getDocumentByIdForPipelineExecution(String aiResourceGroup, String pipelineId, String executionId, String documentId)`
  Get Document by ID for a Pipeline Execution
  `DocumentsStatusResponse`
  `getDocumentsForPipelineExecution(String aiResourceGroup, String pipelineId, String executionId)`
  Get Documents for a Pipeline Execution
  `DocumentsStatusResponse`
  `getDocumentsForPipelineExecution(String aiResourceGroup, String pipelineId, String executionId, Integer $top, Integer $skip, Boolean $count)`
  Get Documents for a Pipeline Execution
  `GetPipelineExecutionById`
  `getExecutionDetailsByIdForPipelineExecution(String aiResourceGroup, String pipelineId, String executionId)`
  Get Pipeline Execution by ID
  `GetPipeline`
  `getPipelineById(String aiResourceGroup, String pipelineId)`
  Get details of a Pipeline
  `GetPipelineStatus`
  `getPipelineStatus(String aiResourceGroup, String pipelineId)`
  Get status of Pipeline
  `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiResponse`
  `manualTriggerPipeline(String aiResourceGroup, ManualPipelineTrigger manualPipelineTrigger)`
  Pipeline Trigger
  `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiResponse`
  `patchPipelineById(String aiResourceGroup, String pipelineId, PatchPipeline patchPipeline)`
  Patch pipeline
  `SearchPipelinesResponse`
  `searchPipelinesByMetadata(String aiResourceGroup, SearchPipeline searchPipeline)`
  Pipeline Search by Metadata
  `SearchPipelinesResponse`
  `searchPipelinesByMetadata(String aiResourceGroup, SearchPipeline searchPipeline, Integer $top, Integer $skip, Boolean $count)`
  Pipeline Search by Metadata
  `PipelinesApi`
  `withDefaultHeaders(Map<String,String> defaultHeaders)`
  Creates a new API instance with additional default headers.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### PipelinesApi

    public PipelinesApi(@Nonnull com.sap.cloud.sdk.cloudplatform.connectivity.Destination httpDestination)
    Instantiates this API class to invoke operations on the Grounding.
    Parameters:
      `httpDestination` - The destination that API should be used with

  - ### PipelinesApi

    public PipelinesApi(@Nonnull com.sap.cloud.sdk.services.openapi.apache.apiclient.ApiClient apiClient)
    Instantiates this API class to invoke operations on the Grounding based on a given `ApiClient`.
    Parameters:
      `apiClient` - ApiClient to invoke the API on

- ## Method Details

  - ### withDefaultHeaders

    public PipelinesApi withDefaultHeaders(@Nonnull Map<String,String> defaultHeaders)
    Creates a new API instance with additional default headers.
    Parameters:
      `defaultHeaders` - Additional headers to include in all requests
    Returns:
      A new API instance with the combined headers

  - ### createPipeline

    @Nonnull public PipelineId createPipeline(@Nonnull String aiResourceGroup, @Nonnull CreatePipeline createPipeline) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Pipeline Creation

    Create a pipeline

    201 - Returns pipelineId on successful creation.

    400 - The specification of the resource was incorrect

    Parameters:
      `aiResourceGroup` - Resource Group ID
      `createPipeline` - The value for the parameter createPipeline
    Returns:
      PipelineId
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### deletePipelineById

    @Nonnull public com.sap.cloud.sdk.services.openapi.apache.core.OpenApiResponse deletePipelineById(@Nonnull String aiResourceGroup, @Nonnull String pipelineId) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Delete pipeline

    Delete a pipeline by pipeline id

    204 - No Content

    400 - The specification of the resource was incorrect

    Parameters:
      `aiResourceGroup` - Resource Group ID
      `pipelineId` - The ID of the pipeline to delete.
    Returns:
      An OpenApiResponse containing the status code of the HttpResponse.
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### getAllPipelines

    @Nonnull public GetPipelines getAllPipelines(@Nonnull String aiResourceGroup, @Nullable String metadataConfigId, @Nullable Integer $top, @Nullable Integer $skip, @Nullable Boolean $count) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Get Pipelines

    Get all pipelines

    200 - Returns all pipelines for the tenant.

    400 - The specification of the resource was incorrect

    Parameters:
      `aiResourceGroup` - (required) Resource Group ID
      `metadataConfigId` - (optional) Filter pipelines based on metadataConfigId
      `$top` - (optional) Number of results to display
      `$skip` - (optional) Number of results to be skipped from the ordered list of results
      `$count` - (optional) When the $count field is set to false, the response contains a count of the items present in the response. When the $count field is set to true, the response contains a count of all the items present on the server, and not just the ones in the response. When the $count field is not passed, it is false by default.
    Returns:
      GetPipelines
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### getAllPipelines

    @Nonnull public GetPipelines getAllPipelines(@Nonnull String aiResourceGroup) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Get Pipelines

    Get all pipelines

    200 - Returns all pipelines for the tenant.

    400 - The specification of the resource was incorrect

    Parameters:
      `aiResourceGroup` - Resource Group ID
    Returns:
      GetPipelines
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### getPipelineById

    @Nonnull public GetPipeline getPipelineById(@Nonnull String aiResourceGroup, @Nonnull String pipelineId) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Get details of a Pipeline

    Get details of a pipeline by pipeline id

    200 - Returns the pipeline for an pipelineId

    400 - The specification of the resource was incorrect

    Parameters:
      `aiResourceGroup` - Resource Group ID
      `pipelineId` - The ID of the pipeline to get.
    Returns:
      GetPipeline
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### getDocumentByIdForPipeline

    @Nonnull public PipelineDocumentResponse getDocumentByIdForPipeline(@Nonnull String aiResourceGroup, @Nonnull String pipelineId, @Nonnull String documentId) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Get Document by ID for a Pipeline

    Retrieve details of a specific document associated with a pipeline.

    200 - Returns a response to document id.

    Parameters:
      `aiResourceGroup` - Resource Group ID
      `pipelineId` - The ID of the pipeline to get.
      `documentId` - The ID of the document to get.
    Returns:
      PipelineDocumentResponse
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### getAllDocumentsForPipeline

    @Nonnull public DocumentsStatusResponse getAllDocumentsForPipeline(@Nonnull String aiResourceGroup, @Nonnull String pipelineId, @Nullable Integer $top, @Nullable Integer $skip, @Nullable Boolean $count) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Get Documents for a Pipeline

    Retrieve all documents associated with a specific pipeline. Optionally, filter the results using query parameters.

    200 - Returns all documents for a pipeline.

    Parameters:
      `aiResourceGroup` - (required) Resource Group ID
      `pipelineId` - (required) The ID of the pipeline to get.
      `$top` - (optional) Number of results to display
      `$skip` - (optional) Number of results to be skipped from the ordered list of results
      `$count` - (optional) When the $count field is set to false, the response contains a count of the items present in the response. When the $count field is set to true, the response contains a count of all the items present on the server, and not just the ones in the response. When the $count field is not passed, it is false by default.
    Returns:
      DocumentsStatusResponse
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### getAllDocumentsForPipeline

    @Nonnull public DocumentsStatusResponse getAllDocumentsForPipeline(@Nonnull String aiResourceGroup, @Nonnull String pipelineId) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Get Documents for a Pipeline

    Retrieve all documents associated with a specific pipeline. Optionally, filter the results using query parameters.

    200 - Returns all documents for a pipeline.

    Parameters:
      `aiResourceGroup` - Resource Group ID
      `pipelineId` - The ID of the pipeline to get.
    Returns:
      DocumentsStatusResponse
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### getExecutionDetailsByIdForPipelineExecution

    @Nonnull public GetPipelineExecutionById getExecutionDetailsByIdForPipelineExecution(@Nonnull String aiResourceGroup, @Nonnull String pipelineId, @Nonnull String executionId) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Get Pipeline Execution by ID

    Retrieve details of a specific pipeline execution by its execution ID.

    200 - Returns a response to execution id

    Parameters:
      `aiResourceGroup` - Resource Group ID
      `pipelineId` - The ID of the pipeline
      `executionId` - The ID of the execution
    Returns:
      GetPipelineExecutionById
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### getDocumentByIdForPipelineExecution

    @Nonnull public PipelineDocumentResponse getDocumentByIdForPipelineExecution(@Nonnull String aiResourceGroup, @Nonnull String pipelineId, @Nonnull String executionId, @Nonnull String documentId) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Get Document by ID for a Pipeline Execution

    Retrieve details of a specific document associated with a pipeline execution.

    200 - Returns a response to execution id and document id.

    Parameters:
      `aiResourceGroup` - Resource Group ID
      `pipelineId` - The ID of the pipeline
      `executionId` - The ID of the execution
      `documentId` - The ID of the document to get.
    Returns:
      PipelineDocumentResponse
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### getDocumentsForPipelineExecution

    @Nonnull public DocumentsStatusResponse getDocumentsForPipelineExecution(@Nonnull String aiResourceGroup, @Nonnull String pipelineId, @Nonnull String executionId, @Nullable Integer $top, @Nullable Integer $skip, @Nullable Boolean $count) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Get Documents for a Pipeline Execution

    Retrieve all documents associated with a specific pipeline execution. Optionally, filter the results using query parameters.

    200 - Returns a response to execution id

    Parameters:
      `aiResourceGroup` - (required) Resource Group ID
      `pipelineId` - (required) The ID of the pipeline
      `executionId` - (required) The ID of the execution
      `$top` - (optional) Number of results to display
      `$skip` - (optional) Number of results to be skipped from the ordered list of results
      `$count` - (optional) When the $count field is set to false, the response contains a count of the items present in the response. When the $count field is set to true, the response contains a count of all the items present on the server, and not just the ones in the response. When the $count field is not passed, it is false by default.
    Returns:
      DocumentsStatusResponse
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### getDocumentsForPipelineExecution

    @Nonnull public DocumentsStatusResponse getDocumentsForPipelineExecution(@Nonnull String aiResourceGroup, @Nonnull String pipelineId, @Nonnull String executionId) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Get Documents for a Pipeline Execution

    Retrieve all documents associated with a specific pipeline execution. Optionally, filter the results using query parameters.

    200 - Returns a response to execution id

    Parameters:
      `aiResourceGroup` - Resource Group ID
      `pipelineId` - The ID of the pipeline
      `executionId` - The ID of the execution
    Returns:
      DocumentsStatusResponse
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### getAllExecutionsForPipeline

    @Nonnull public GetPipelineExecutions getAllExecutionsForPipeline(@Nonnull String aiResourceGroup, @Nonnull String pipelineId, @Nullable Boolean lastExecution, @Nullable Integer $top, @Nullable Integer $skip, @Nullable Boolean $count) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Get Pipeline Executions

    Retrieve all executions for a specific pipeline. Optionally, filter to get only the last execution.

    200 - Returns all executions

    Parameters:
      `aiResourceGroup` - (required) Resource Group ID
      `pipelineId` - (required) The ID of the pipeline
      `lastExecution` - (optional) Filter to get the last execution
      `$top` - (optional) Number of results to display
      `$skip` - (optional) Number of results to be skipped from the ordered list of results
      `$count` - (optional) When the $count field is set to false, the response contains a count of the items present in the response. When the $count field is set to true, the response contains a count of all the items present on the server, and not just the ones in the response. When the $count field is not passed, it is false by default.
    Returns:
      GetPipelineExecutions
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### getAllExecutionsForPipeline

    @Nonnull public GetPipelineExecutions getAllExecutionsForPipeline(@Nonnull String aiResourceGroup, @Nonnull String pipelineId) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Get Pipeline Executions

    Retrieve all executions for a specific pipeline. Optionally, filter to get only the last execution.

    200 - Returns all executions

    Parameters:
      `aiResourceGroup` - Resource Group ID
      `pipelineId` - The ID of the pipeline
    Returns:
      GetPipelineExecutions
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### getPipelineStatus

    @Nonnull public GetPipelineStatus getPipelineStatus(@Nonnull String aiResourceGroup, @Nonnull String pipelineId) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Get status of Pipeline

    Get pipeline status by pipeline id

    200 - Returns the pipeline status for an pipelineId.

    400 - The specification of the resource was incorrect

    Parameters:
      `aiResourceGroup` - Resource Group ID
      `pipelineId` - The ID of the pipeline to get status.
    Returns:
      GetPipelineStatus
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### patchPipelineById

    @Nonnull public com.sap.cloud.sdk.services.openapi.apache.core.OpenApiResponse patchPipelineById(@Nonnull String aiResourceGroup, @Nonnull String pipelineId, @Nonnull PatchPipeline patchPipeline) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Patch pipeline

    Patch a pipeline by pipeline id

    204 - No Content

    400 - The specification of the resource was incorrect

    Parameters:
      `aiResourceGroup` - Resource Group ID
      `pipelineId` - The ID of the pipeline to patch.
      `patchPipeline` - The value for the parameter patchPipeline
    Returns:
      An OpenApiResponse containing the status code of the HttpResponse.
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### searchPipelinesByMetadata

    @Nonnull public SearchPipelinesResponse searchPipelinesByMetadata(@Nonnull String aiResourceGroup, @Nonnull SearchPipeline searchPipeline, @Nullable Integer $top, @Nullable Integer $skip, @Nullable Boolean $count) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Pipeline Search by Metadata

    Search for pipelines based on metadata

    200 - Returns pipelines for the tenant that matches the metadata

    400 - The specification of the resource was incorrect

    Parameters:
      `aiResourceGroup` - (required) Resource Group ID
      `searchPipeline` - (required) The value for the parameter searchPipeline
      `$top` - (optional) Number of results to display
      `$skip` - (optional) Number of results to be skipped from the ordered list of results
      `$count` - (optional) When the $count field is set to false, the response contains a count of the items present in the response. When the $count field is set to true, the response contains a count of all the items present on the server, and not just the ones in the response. When the $count field is not passed, it is false by default.
    Returns:
      SearchPipelinesResponse
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### searchPipelinesByMetadata

    @Nonnull public SearchPipelinesResponse searchPipelinesByMetadata(@Nonnull String aiResourceGroup, @Nonnull SearchPipeline searchPipeline) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Pipeline Search by Metadata

    Search for pipelines based on metadata

    200 - Returns pipelines for the tenant that matches the metadata

    400 - The specification of the resource was incorrect

    Parameters:
      `aiResourceGroup` - Resource Group ID
      `searchPipeline` - The value for the parameter searchPipeline
    Returns:
      SearchPipelinesResponse
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API

  - ### manualTriggerPipeline

    @Nonnull public com.sap.cloud.sdk.services.openapi.apache.core.OpenApiResponse manualTriggerPipeline(@Nonnull String aiResourceGroup, @Nonnull ManualPipelineTrigger manualPipelineTrigger) throws com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException
    Pipeline Trigger

    Manually trigger a pipeline

    202 - Accepted

    400 - The specification of the resource was incorrect

    Parameters:
      `aiResourceGroup` - Resource Group ID
      `manualPipelineTrigger` - The value for the parameter manualPipelineTrigger
    Returns:
      An OpenApiResponse containing the status code of the HttpResponse.
    Throws:
      `com.sap.cloud.sdk.services.openapi.apache.core.OpenApiRequestException` - if an error occurs while attempting to invoke the API